<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>polylib: compress_parms.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>compress_parms.c File Reference</h1><code>#include &lt;stdlib.h&gt;</code><br/>
<code>#include &lt;<a class="el" href="polylib_8h_source.html">polylib/polylib.h</a>&gt;</code><br/>

<p><a href="compress__parms_8c_source.html">Go to the source code of this file.</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Defines</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="compress__parms_8c.html#a22fb119bf6f583cf5b74c2bddaa53e70">dbgCompParm</a>&nbsp;&nbsp;&nbsp;0</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><dl class="rcs"><dt><b>Id</b></dt><dd><a class="el" href="compress__parms_8c.html">compress_parms.c</a>,v 1.32 2006/11/03 17:34:26 skimo Exp </dd></dl>
 <a href="#a22fb119bf6f583cf5b74c2bddaa53e70"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="compress__parms_8c.html#a964f66a0f36b5e1d0dea475066c53ca0">dbgCompParmMore</a>&nbsp;&nbsp;&nbsp;0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="compress__parms_8c.html#a4df7b5873f125cf5c2976bbd4dcfe168">dbgStart</a>(a)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="compress__parms_8c.html#a49fcecacd32fa2357935cb5a4f542e0c">dbgEnd</a>(a)</td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="compress__parms_8c.html#ad66769b920ca4596c9fe5b76d38d0b3b">int_ker</a> (<a class="el" href="structmatrix.html">Matrix</a> *M)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Given a full-row-rank nxm <a class="el" href="structmatrix.html">matrix</a> M made of m row-vectors), computes the basis K (made of n-m column-vectors) of the integer kernel of the rows of M so we have: M.K = 0.  <a href="#ad66769b920ca4596c9fe5b76d38d0b3b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="compress__parms_8c.html#a8b044a0b5721eb247eb671644b80df9d">linearInter</a> (<a class="el" href="structmatrix.html">Matrix</a> *A, <a class="el" href="structmatrix.html">Matrix</a> *B, <a class="el" href="structmatrix.html">Matrix</a> **I, <a class="el" href="structmatrix.html">Matrix</a> **Lb)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Computes the intersection of two linear lattices, whose base vectors are respectively represented in A and B.  <a href="#a8b044a0b5721eb247eb671644b80df9d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="compress__parms_8c.html#a0395c4623907612a51219536d4d258e6">Equalities_integerSolution</a> (<a class="el" href="structmatrix.html">Matrix</a> *Eqs, <a class="el" href="structmatrix.html">Matrix</a> **I)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Given a system of equalities, looks if it has an integer solution in the combined space, and if yes, returns one solution.  <a href="#a0395c4623907612a51219536d4d258e6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="compress__parms_8c.html#ae018fc28835ce2d99a74dba09055acc0">Equalities_validityLattice</a> (<a class="el" href="structmatrix.html">Matrix</a> *Eqs, int a, <a class="el" href="structmatrix.html">Matrix</a> **vl)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Computes the validity lattice of a set of equalities.  <a href="#ae018fc28835ce2d99a74dba09055acc0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="compress__parms_8c.html#a3efbee2cc61c1cfb2e0b05f3320a2e83">Constraints_removeElimCols</a> (<a class="el" href="structmatrix.html">Matrix</a> *M, unsigned int nbVars, unsigned int *elimParms, <a class="el" href="structmatrix.html">Matrix</a> **newM)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Eliminate the columns corresponding to a list of eliminated parameters.  <a href="#a3efbee2cc61c1cfb2e0b05f3320a2e83"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="compress__parms_8c.html#a1a9cd66aec30116cfd3b07c2e38c73c8">Constraints_fullDimensionize</a> (<a class="el" href="structmatrix.html">Matrix</a> **M, <a class="el" href="structmatrix.html">Matrix</a> **C, <a class="el" href="structmatrix.html">Matrix</a> **VL, <a class="el" href="structmatrix.html">Matrix</a> **Eqs, <a class="el" href="structmatrix.html">Matrix</a> **ParmEqs, unsigned int **elimVars, unsigned int **elimParms, int maxRays)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Eliminates all the equalities in a set of constraints and returns the set of constraints defining a full-dimensional <a class="el" href="structpolyhedron.html">polyhedron</a>, such that there is a bijection between integer points of the original <a class="el" href="structpolyhedron.html">polyhedron</a> and these of the resulting (projected) <a class="el" href="structpolyhedron.html">polyhedron</a>).  <a href="#a1a9cd66aec30116cfd3b07c2e38c73c8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="compress__parms_8c.html#a9a39676ea22cef575c08911c95badba2">Lattice_extractSubLattice</a> (<a class="el" href="structmatrix.html">Matrix</a> *lat, unsigned int k, <a class="el" href="structmatrix.html">Matrix</a> **subLat)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Given a <a class="el" href="structmatrix.html">matrix</a> that defines a full-dimensional affine lattice, returns the affine sub-lattice spanned in the k first dimensions.  <a href="#a9a39676ea22cef575c08911c95badba2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="compress__parms_8c.html#abfe5775031fc1fc8b783ef3a248a18b0">affine_periods</a> (<a class="el" href="structmatrix.html">Matrix</a> *M, <a class="el" href="structmatrix.html">Matrix</a> *d)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Computes the overall period of the variables I for (MI) mod |d|, where M is a <a class="el" href="structmatrix.html">matrix</a> and |d| a vector.  <a href="#abfe5775031fc1fc8b783ef3a248a18b0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="compress__parms_8c.html#a12b7b863af43c3d85682b9df2385938c">Equalities_intModBasis</a> (<a class="el" href="structmatrix.html">Matrix</a> *B, <a class="el" href="structmatrix.html">Matrix</a> *C, <a class="el" href="structmatrix.html">Matrix</a> *d, <a class="el" href="structmatrix.html">Matrix</a> **imb)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Given an integer <a class="el" href="structmatrix.html">matrix</a> B with m rows and integer m-vectors C and d, computes the basis of the integer solutions to (BN+C) mod d = 0 (1).  <a href="#a12b7b863af43c3d85682b9df2385938c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="compress__parms_8c.html#a091ae8062b33511134d13b0035a56777">int_mod_basis</a> (<a class="el" href="structmatrix.html">Matrix</a> *B, <a class="el" href="structmatrix.html">Matrix</a> *C, <a class="el" href="structmatrix.html">Matrix</a> *d)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">kept here for backwards compatiblity.  <a href="#a091ae8062b33511134d13b0035a56777"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="compress__parms_8c.html#a4877b02bfffc51db4d9ac702475c3765">compress_parms</a> (<a class="el" href="structmatrix.html">Matrix</a> *E, int nbParms)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Given a parameterized constraints <a class="el" href="structmatrix.html">matrix</a> with m equalities, computes the compression <a class="el" href="structmatrix.html">matrix</a> G such that there is an integer solution in the variables space for each value of N', with N = G N' (N are the "nb_parms" parameters).  <a href="#a4877b02bfffc51db4d9ac702475c3765"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="compress__parms_8c.html#aca0035f9313236fd8046ab042180f544">Constraints_Remove_parm_eqs</a> (<a class="el" href="structmatrix.html">Matrix</a> **M1, <a class="el" href="structmatrix.html">Matrix</a> **Ctxt1, int renderSpace, unsigned int **elimParms)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Removes the equalities that involve only parameters, by eliminating some parameters in the polyhedron's constraints and in the context.  <a href="#aca0035f9313236fd8046ab042180f544"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structpolyhedron.html">Polyhedron</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="compress__parms_8c.html#a86df15994f14c73d49980bbf61f6f7e5">Polyhedron_Remove_parm_eqs</a> (<a class="el" href="structpolyhedron.html">Polyhedron</a> **P, <a class="el" href="structpolyhedron.html">Polyhedron</a> **C, int renderSpace, unsigned int **elimParms, int maxRays)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Removes equalities involving only parameters, but starting from a Polyhedron and its context.  <a href="#a86df15994f14c73d49980bbf61f6f7e5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="compress__parms_8c.html#ab67657b853a34d82fdc72a3f771bc72c">full_dimensionize</a> (<a class="el" href="structmatrix.html">Matrix</a> const *M, int nbParms, <a class="el" href="structmatrix.html">Matrix</a> **validityLattice)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Given a <a class="el" href="structmatrix.html">matrix</a> with m parameterized equations, compress the nb_parms parameters and n-m variables so that m variables are integer, and transform the variable space into a n-m space by eliminating the m variables (using the equalities) the variables to be eliminated are chosen automatically by the function.  <a href="#ab67657b853a34d82fdc72a3f771bc72c"></a><br/></td></tr>
</table>
<hr/><h2>Define Documentation</h2>
<a class="anchor" id="a22fb119bf6f583cf5b74c2bddaa53e70"></a><!-- doxytag: member="compress_parms.c::dbgCompParm" ref="a22fb119bf6f583cf5b74c2bddaa53e70" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define dbgCompParm&nbsp;&nbsp;&nbsp;0</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p><dl class="rcs"><dt><b>Id</b></dt><dd><a class="el" href="compress__parms_8c.html">compress_parms.c</a>,v 1.32 2006/11/03 17:34:26 skimo Exp </dd></dl>
</p>
<p>The integer points in a parametric linear subspace of Q^n are generally lying on a sub-lattice of Z^n. Functions here use and compute validity lattices, i.e. lattices induced on a set of variables by such equalities involving another set of integer variables. </p>
<dl class="author"><dt><b>Author:</b></dt><dd>B. Meister 12/2003-2006 <a href="mailto:meister@icps.u-strasbg.fr">meister@icps.u-strasbg.fr</a> LSIIT -ICPS UMR 7005 CNRS Louis Pasteur University (ULP), Strasbourg, France debug flags (2 levels) </dd></dl>

<p>Definition at line <a class="el" href="compress__parms_8c_source.html#l00038">38</a> of file <a class="el" href="compress__parms_8c_source.html">compress_parms.c</a>.</p>

<p>Referenced by <a class="el" href="compress__parms_8c_source.html#l00386">Constraints_fullDimensionize()</a>, <a class="el" href="compress__parms_8c_source.html#l00181">Equalities_integerSolution()</a>, <a class="el" href="compress__parms_8c_source.html#l00271">Equalities_validityLattice()</a>, <a class="el" href="compress__parms_8c_source.html#l00904">full_dimensionize()</a>, <a class="el" href="compress__parms_8c_source.html#l00056">int_ker()</a>, and <a class="el" href="compress__parms_8c_source.html#l00119">linearInter()</a>.</p>

</div>
</div>
<a class="anchor" id="a964f66a0f36b5e1d0dea475066c53ca0"></a><!-- doxytag: member="compress_parms.c::dbgCompParmMore" ref="a964f66a0f36b5e1d0dea475066c53ca0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define dbgCompParmMore&nbsp;&nbsp;&nbsp;0</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="compress__parms_8c_source.html#l00039">39</a> of file <a class="el" href="compress__parms_8c_source.html">compress_parms.c</a>.</p>

<p>Referenced by <a class="el" href="compress__parms_8c_source.html#l00386">Constraints_fullDimensionize()</a>, <a class="el" href="compress__parms_8c_source.html#l00181">Equalities_integerSolution()</a>, <a class="el" href="compress__parms_8c_source.html#l00056">int_ker()</a>, and <a class="el" href="compress__parms_8c_source.html#l00499">Lattice_extractSubLattice()</a>.</p>

</div>
</div>
<a class="anchor" id="a49fcecacd32fa2357935cb5a4f542e0c"></a><!-- doxytag: member="compress_parms.c::dbgEnd" ref="a49fcecacd32fa2357935cb5a4f542e0c" args="(a)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define dbgEnd</td>
          <td>(</td>
          <td class="paramtype">a&nbsp;</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<b>Value:</b><div class="fragment"><pre class="fragment"><span class="keywordflow">if</span> (<a class="code" href="compress__parms_8c.html#a964f66a0f36b5e1d0dea475066c53ca0">dbgCompParmMore</a>) { printf(<span class="stringliteral">&quot; -- end &quot;</span>); \
                                         printf(#a);      \
                                         printf(<span class="stringliteral">&quot; --\n&quot;</span>); } \
                                         <span class="keywordflow">while</span>(0)
</pre></div>
<p>Definition at line <a class="el" href="compress__parms_8c_source.html#l00045">45</a> of file <a class="el" href="compress__parms_8c_source.html">compress_parms.c</a>.</p>

<p>Referenced by <a class="el" href="compress__parms_8c_source.html#l00499">Lattice_extractSubLattice()</a>.</p>

</div>
</div>
<a class="anchor" id="a4df7b5873f125cf5c2976bbd4dcfe168"></a><!-- doxytag: member="compress_parms.c::dbgStart" ref="a4df7b5873f125cf5c2976bbd4dcfe168" args="(a)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define dbgStart</td>
          <td>(</td>
          <td class="paramtype">a&nbsp;</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<b>Value:</b><div class="fragment"><pre class="fragment"><span class="keywordflow">if</span> (<a class="code" href="compress__parms_8c.html#a964f66a0f36b5e1d0dea475066c53ca0">dbgCompParmMore</a>) { printf(<span class="stringliteral">&quot; -- begin &quot;</span>); \
                                           printf(#a);        \
                                           printf(<span class="stringliteral">&quot; --\n&quot;</span>); }   \
                                           <span class="keywordflow">while</span>(0)
</pre></div>
<p>Definition at line <a class="el" href="compress__parms_8c_source.html#l00041">41</a> of file <a class="el" href="compress__parms_8c_source.html">compress_parms.c</a>.</p>

<p>Referenced by <a class="el" href="compress__parms_8c_source.html#l00499">Lattice_extractSubLattice()</a>.</p>

</div>
</div>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="abfe5775031fc1fc8b783ef3a248a18b0"></a><!-- doxytag: member="compress_parms.c::affine_periods" ref="abfe5775031fc1fc8b783ef3a248a18b0" args="(Matrix *M, Matrix *d)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structmatrix.html">Matrix</a>* affine_periods </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>M</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>d</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Computes the overall period of the variables I for (MI) mod |d|, where M is a <a class="el" href="structmatrix.html">matrix</a> and |d| a vector. </p>
<p>Produce a diagonal <a class="el" href="structmatrix.html">matrix</a> S = (s_k) where s_k is the overall period of i_k </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>M</em>&nbsp;</td><td>the set of affine functions of I (row-vectors) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>d</em>&nbsp;</td><td>the column-vector representing the modulos </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="compress__parms_8c_source.html#l00548">548</a> of file <a class="el" href="compress__parms_8c_source.html">compress_parms.c</a>.</p>

<p>References <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00524">value_divexact</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00532">value_gcd</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00533">value_lcm</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00460">value_set_si</a>.</p>

</div>
</div>
<a class="anchor" id="a4877b02bfffc51db4d9ac702475c3765"></a><!-- doxytag: member="compress_parms.c::compress_parms" ref="a4877b02bfffc51db4d9ac702475c3765" args="(Matrix *E, int nbParms)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structmatrix.html">Matrix</a>* compress_parms </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>E</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>nbParms</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Given a parameterized constraints <a class="el" href="structmatrix.html">matrix</a> with m equalities, computes the compression <a class="el" href="structmatrix.html">matrix</a> G such that there is an integer solution in the variables space for each value of N', with N = G N' (N are the "nb_parms" parameters). </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>E</em>&nbsp;</td><td>a <a class="el" href="structmatrix.html">matrix</a> of parametric equalities </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>nb_parms</em>&nbsp;</td><td>the number of parameters <b>Note: </b>this function is mostly here for backwards compatibility. Prefer the use of <code>Equalities_validityLattice</code>. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="compress__parms_8c_source.html#l00630">630</a> of file <a class="el" href="compress__parms_8c_source.html">compress_parms.c</a>.</p>

<p>References <a class="el" href="compress__parms_8c_source.html#l00271">Equalities_validityLattice()</a>, and <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>.</p>

<p>Referenced by <a class="el" href="compress__parms_8c_source.html#l00904">full_dimensionize()</a>.</p>

</div>
</div>
<a class="anchor" id="a1a9cd66aec30116cfd3b07c2e38c73c8"></a><!-- doxytag: member="compress_parms.c::Constraints_fullDimensionize" ref="a1a9cd66aec30116cfd3b07c2e38c73c8" args="(Matrix **M, Matrix **C, Matrix **VL, Matrix **Eqs, Matrix **ParmEqs, unsigned int **elimVars, unsigned int **elimParms, int maxRays)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Constraints_fullDimensionize </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>M</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>C</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>VL</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>Eqs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>ParmEqs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int **&nbsp;</td>
          <td class="paramname"> <em>elimVars</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int **&nbsp;</td>
          <td class="paramname"> <em>elimParms</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>maxRays</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Eliminates all the equalities in a set of constraints and returns the set of constraints defining a full-dimensional <a class="el" href="structpolyhedron.html">polyhedron</a>, such that there is a bijection between integer points of the original <a class="el" href="structpolyhedron.html">polyhedron</a> and these of the resulting (projected) <a class="el" href="structpolyhedron.html">polyhedron</a>). </p>
<p>If VL is set to NULL, this funciton allocates it. Else, it assumes that (*VL) points to a <a class="el" href="structmatrix.html">matrix</a> of the right size. </p>
<p>The following things are done: </p>
<ol>
<li>
remove equalities involving only parameters, and remove as many parameters as there are such equalities. From that, the list of eliminated parameters <em>elimParms</em> is built. </li>
<li>
remove equalities that involve variables. This requires a compression of the parameters and of the other variables that are not eliminated. The affine compresson is represented by <a class="el" href="structmatrix.html">matrix</a> VL (for <em>validity lattice</em>) and is such that (N I 1)^T = VL.(N' I' 1), where N', I' are integer (they are the parameters and variables after compression). </li>
</ol>

<p>Definition at line <a class="el" href="compress__parms_8c_source.html#l00386">386</a> of file <a class="el" href="compress__parms_8c_source.html">compress_parms.c</a>.</p>

<p>References <a class="el" href="assert_8h_source.html#l00026">assert</a>, <a class="el" href="matrix__addon_8h_source.html#l00094">Constraints_compressLastVars</a>, <a class="el" href="matrix__addon_8h_source.html#l00102">Constraints_eliminateFirstVars</a>, <a class="el" href="matrix__permutations_8c_source.html#l00104">Constraints_permute()</a>, <a class="el" href="compress__parms_8c_source.html#l00335">Constraints_removeElimCols()</a>, <a class="el" href="compress__parms_8h_source.html#l00072">Constraints_removeParmEqs</a>, <a class="el" href="compress__parms_8c_source.html#l00038">dbgCompParm</a>, <a class="el" href="compress__parms_8c_source.html#l00039">dbgCompParmMore</a>, <a class="el" href="compress__parms_8c_source.html#l00271">Equalities_validityLattice()</a>, <a class="el" href="matrix__permutations_8c_source.html#l00213">find_a_permutation()</a>, <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="matrix_8c_source.html#l00092">Matrix_Free()</a>, <a class="el" href="matrix__addon_8c_source.html#l00099">Matrix_identity()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="matrix__addon_8h_source.html#l00032">show_matrix</a>, <a class="el" href="matrix__addon_8c_source.html#l00050">split_constraints()</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00460">value_set_si</a>.</p>

<p>Referenced by <a class="el" href="testCompressParms_8c_source.html#l00273">test_Constraints_fullDimensionize()</a>.</p>

</div>
</div>
<a class="anchor" id="aca0035f9313236fd8046ab042180f544"></a><!-- doxytag: member="compress_parms.c::Constraints_Remove_parm_eqs" ref="aca0035f9313236fd8046ab042180f544" args="(Matrix **M1, Matrix **Ctxt1, int renderSpace, unsigned int **elimParms)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structmatrix.html">Matrix</a>* Constraints_Remove_parm_eqs </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>M1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>Ctxt1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>renderSpace</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int **&nbsp;</td>
          <td class="paramname"> <em>elimParms</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Removes the equalities that involve only parameters, by eliminating some parameters in the polyhedron's constraints and in the context. </p>
<p><b>Updates M and Ctxt.</b> </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>M1</em>&nbsp;</td><td>the polyhedron's constraints </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>Ctxt1</em>&nbsp;</td><td>the constraints of the polyhedron's context </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>renderSpace</em>&nbsp;</td><td>tells if the returned equalities must be expressed in the parameters space (renderSpace=0) or in the combined var/parms space (renderSpace = 1) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>elimParms</em>&nbsp;</td><td>the list of parameters that have been removed: an array whose 1st element is the number of elements in the list. (returned) </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>the system of equalities that involve only parameters. </dd></dl>

<p>Definition at line <a class="el" href="compress__parms_8c_source.html#l00649">649</a> of file <a class="el" href="compress__parms_8c_source.html">compress_parms.c</a>.</p>

<p>References <a class="el" href="matrix__addon_8c_source.html#l00241">eliminate_var_with_constr()</a>, <a class="el" href="vector_8c_source.html#l00137">First_Non_Zero()</a>, <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="matrix_8c_source.html#l00092">Matrix_Free()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="matrix__addon_8h_source.html#l00032">show_matrix</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00559">value_cmp_si</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00554">value_notzero_p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00460">value_set_si</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00553">value_zero_p</a>, and <a class="el" href="vector_8c_source.html#l00269">Vector_Copy()</a>.</p>

<p>Referenced by <a class="el" href="ehrhart_8c_source.html#l02677">Constraints_EhrhartQuickApx()</a>, <a class="el" href="compress__parms_8c_source.html#l00856">Polyhedron_Remove_parm_eqs()</a>, and <a class="el" href="testCompressParms_8c_source.html#l00071">test_Constraints_Remove_parm_eqs()</a>.</p>

</div>
</div>
<a class="anchor" id="a3efbee2cc61c1cfb2e0b05f3320a2e83"></a><!-- doxytag: member="compress_parms.c::Constraints_removeElimCols" ref="a3efbee2cc61c1cfb2e0b05f3320a2e83" args="(Matrix *M, unsigned int nbVars, unsigned int *elimParms, Matrix **newM)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Constraints_removeElimCols </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>M</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&nbsp;</td>
          <td class="paramname"> <em>nbVars</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int *&nbsp;</td>
          <td class="paramname"> <em>elimParms</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>newM</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Eliminate the columns corresponding to a list of eliminated parameters. </p>
<p>Eliminates the columns corresponding to a list of eliminated parameters.</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>M</em>&nbsp;</td><td>the constraints <a class="el" href="structmatrix.html">matrix</a> whose columns are to be removed </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>nbVars</em>&nbsp;</td><td>an offset to be added to the ranks of the variables to be removed </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>elimParms</em>&nbsp;</td><td>the list of ranks of the variables to be removed </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>newM</em>&nbsp;</td><td>(output) the <a class="el" href="structmatrix.html">matrix</a> without the removed columns </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="compress__parms_8c_source.html#l00335">335</a> of file <a class="el" href="compress__parms_8c_source.html">compress_parms.c</a>.</p>

<p>References <a class="el" href="assert_8h_source.html#l00026">assert</a>, <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="matrix__addon_8c_source.html#l00377">Matrix_clone()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, and <a class="el" href="vector_8c_source.html#l00269">Vector_Copy()</a>.</p>

<p>Referenced by <a class="el" href="compress__parms_8c_source.html#l00386">Constraints_fullDimensionize()</a>.</p>

</div>
</div>
<a class="anchor" id="a0395c4623907612a51219536d4d258e6"></a><!-- doxytag: member="compress_parms.c::Equalities_integerSolution" ref="a0395c4623907612a51219536d4d258e6" args="(Matrix *Eqs, Matrix **I)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Equalities_integerSolution </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>Eqs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>I</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Given a system of equalities, looks if it has an integer solution in the combined space, and if yes, returns one solution. </p>
<p>Given a system of non-redundant equalities, looks if it has an integer solution in the combined space, and if yes, returns one solution.</p>
<p>pre-condition: the equalities are full-row rank (without the constant part) </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>Eqs</em>&nbsp;</td><td>the system of equations (as constraints) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>I</em>&nbsp;</td><td>a feasible integer solution if it exists, else NULL. Allocated if initially set to NULL, else reused. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="compress__parms_8c_source.html#l00181">181</a> of file <a class="el" href="compress__parms_8c_source.html">compress_parms.c</a>.</p>

<p>References <a class="el" href="compress__parms_8c_source.html#l00038">dbgCompParm</a>, <a class="el" href="compress__parms_8c_source.html#l00039">dbgCompParmMore</a>, <a class="el" href="matrix__addon_8h_source.html#l00041">ensureMatrix</a>, <a class="el" href="matrix_8c_source.html#l00505">left_hermite()</a>, <a class="el" href="matrix_8c_source.html#l00591">MatInverse()</a>, <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="matrix_8c_source.html#l00092">Matrix_Free()</a>, <a class="el" href="matrix__addon_8c_source.html#l00409">Matrix_oppose()</a>, <a class="el" href="matrix_8c_source.html#l00845">Matrix_Product()</a>, <a class="el" href="matrix__addon_8c_source.html#l00357">Matrix_subMatrix()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="matrix__addon_8h_source.html#l00032">show_matrix</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00554">value_notzero_p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00526">value_pdivision</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00527">value_pmodulus</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00460">value_set_si</a>.</p>

<p>Referenced by <a class="el" href="compress__parms_8c_source.html#l00271">Equalities_validityLattice()</a>.</p>

</div>
</div>
<a class="anchor" id="a12b7b863af43c3d85682b9df2385938c"></a><!-- doxytag: member="compress_parms.c::Equalities_intModBasis" ref="a12b7b863af43c3d85682b9df2385938c" args="(Matrix *B, Matrix *C, Matrix *d, Matrix **imb)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Equalities_intModBasis </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>B</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>C</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>d</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>imb</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Given an integer <a class="el" href="structmatrix.html">matrix</a> B with m rows and integer m-vectors C and d, computes the basis of the integer solutions to (BN+C) mod d = 0 (1). </p>
<p>This is an affine lattice (G): (N 1)^T= G(N' 1)^T, forall N' in Z^b. If there is no solution, returns NULL. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>B</em>&nbsp;</td><td>B, a (m x b) <a class="el" href="structmatrix.html">matrix</a> </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>C</em>&nbsp;</td><td>C, a (m x 1) integer <a class="el" href="structmatrix.html">matrix</a> </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>d</em>&nbsp;</td><td>d, a (1 x m) integer <a class="el" href="structmatrix.html">matrix</a> </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>imb</em>&nbsp;</td><td>the affine (b+1)x(b+1) basis of solutions, in the homogeneous form. Allocated if initially set to NULL, reused if not. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="compress__parms_8c_source.html#l00592">592</a> of file <a class="el" href="compress__parms_8c_source.html">compress_parms.c</a>.</p>

<p>References <a class="el" href="compress__parms_8c_source.html#l00271">Equalities_validityLattice()</a>, <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="matrix__addon_8c_source.html#l00394">Matrix_copySubMatrix()</a>, <a class="el" href="matrix_8c_source.html#l00092">Matrix_Free()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>.</p>

<p>Referenced by <a class="el" href="compress__parms_8c_source.html#l00614">int_mod_basis()</a>.</p>

</div>
</div>
<a class="anchor" id="ae018fc28835ce2d99a74dba09055acc0"></a><!-- doxytag: member="compress_parms.c::Equalities_validityLattice" ref="ae018fc28835ce2d99a74dba09055acc0" args="(Matrix *Eqs, int a, Matrix **vl)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Equalities_validityLattice </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>Eqs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>vl</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Computes the validity lattice of a set of equalities. </p>
<p>I.e., the lattice induced on the last <code>b</code> variables by the equalities involving the first <code>a</code> integer existential variables. The submatrix of Eqs that concerns only the existential variables (so the first a columns) is assumed to be full-row rank. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>Eqs</em>&nbsp;</td><td>the equalities </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>a</em>&nbsp;</td><td>the number of existential integer variables, placed as first variables </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>vl</em>&nbsp;</td><td>the (returned) validity lattice, in homogeneous form. It is allocated if initially set to null, or reused if already allocated. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="compress__parms_8c_source.html#l00271">271</a> of file <a class="el" href="compress__parms_8c_source.html">compress_parms.c</a>.</p>

<p>References <a class="el" href="compress__parms_8c_source.html#l00038">dbgCompParm</a>, <a class="el" href="matrix__addon_8h_source.html#l00041">ensureMatrix</a>, <a class="el" href="compress__parms_8c_source.html#l00181">Equalities_integerSolution()</a>, <a class="el" href="matrix_8c_source.html#l00505">left_hermite()</a>, <a class="el" href="compress__parms_8c_source.html#l00119">linearInter()</a>, <a class="el" href="matrix__addon_8c_source.html#l00394">Matrix_copySubMatrix()</a>, <a class="el" href="matrix_8c_source.html#l00092">Matrix_Free()</a>, <a class="el" href="matrix__addon_8c_source.html#l00357">Matrix_subMatrix()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="matrix__addon_8h_source.html#l00032">show_matrix</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00460">value_set_si</a>, and <a class="el" href="vector_8c_source.html#l00240">Vector_Set()</a>.</p>

<p>Referenced by <a class="el" href="compress__parms_8c_source.html#l00630">compress_parms()</a>, <a class="el" href="compress__parms_8c_source.html#l00386">Constraints_fullDimensionize()</a>, and <a class="el" href="compress__parms_8c_source.html#l00592">Equalities_intModBasis()</a>.</p>

</div>
</div>
<a class="anchor" id="ab67657b853a34d82fdc72a3f771bc72c"></a><!-- doxytag: member="compress_parms.c::full_dimensionize" ref="ab67657b853a34d82fdc72a3f771bc72c" args="(Matrix const *M, int nbParms, Matrix **validityLattice)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structmatrix.html">Matrix</a>* full_dimensionize </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> const *&nbsp;</td>
          <td class="paramname"> <em>M</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>nbParms</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>validityLattice</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Given a <a class="el" href="structmatrix.html">matrix</a> with m parameterized equations, compress the nb_parms parameters and n-m variables so that m variables are integer, and transform the variable space into a n-m space by eliminating the m variables (using the equalities) the variables to be eliminated are chosen automatically by the function. </p>
<p><b>Deprecated.</b> Try to use Constraints_fullDimensionize instead. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>M</em>&nbsp;</td><td>the constraints </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>the</em>&nbsp;</td><td>number of parameters </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>validityLattice</em>&nbsp;</td><td>the the integer lattice underlying the integer solutions. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="compress__parms_8c_source.html#l00904">904</a> of file <a class="el" href="compress__parms_8c_source.html">compress_parms.c</a>.</p>

<p>References <a class="el" href="compress__parms_8c_source.html#l00630">compress_parms()</a>, <a class="el" href="compress__parms_8c_source.html#l00038">dbgCompParm</a>, <a class="el" href="matrix__permutations_8c_source.html#l00213">find_a_permutation()</a>, <a class="el" href="matrix__addon_8c_source.html#l00080">Identity_Matrix()</a>, <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="matrix_8c_source.html#l00092">Matrix_Free()</a>, <a class="el" href="matrix__addon_8c_source.html#l00293">mpolyhedron_compress_last_vars()</a>, <a class="el" href="matrix__addon_8c_source.html#l00321">mpolyhedron_eliminate_first_variables()</a>, <a class="el" href="matrix__permutations_8c_source.html#l00085">mpolyhedron_permute()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="matrix__addon_8h_source.html#l00032">show_matrix</a>, <a class="el" href="matrix__addon_8c_source.html#l00050">split_constraints()</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00460">value_set_si</a>.</p>

<p>Referenced by <a class="el" href="ehrhart_8c_source.html#l02635">Ehrhart_Quick_Apx()</a>.</p>

</div>
</div>
<a class="anchor" id="ad66769b920ca4596c9fe5b76d38d0b3b"></a><!-- doxytag: member="compress_parms.c::int_ker" ref="ad66769b920ca4596c9fe5b76d38d0b3b" args="(Matrix *M)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structmatrix.html">Matrix</a>* int_ker </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>M</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Given a full-row-rank nxm <a class="el" href="structmatrix.html">matrix</a> M made of m row-vectors), computes the basis K (made of n-m column-vectors) of the integer kernel of the rows of M so we have: M.K = 0. </p>
<p>given a full-row-rank nxm <a class="el" href="structmatrix.html">matrix</a> M(made of row-vectors), computes the basis K (made of n-m column-vectors) of the integer kernel of M so we have: M.K = 0 </p>

<p>Definition at line <a class="el" href="compress__parms_8c_source.html#l00056">56</a> of file <a class="el" href="compress__parms_8c_source.html">compress_parms.c</a>.</p>

<p>References <a class="el" href="compress__parms_8c_source.html#l00038">dbgCompParm</a>, <a class="el" href="compress__parms_8c_source.html#l00039">dbgCompParmMore</a>, <a class="el" href="matrix_8c_source.html#l00505">left_hermite()</a>, <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="matrix_8c_source.html#l00092">Matrix_Free()</a>, <a class="el" href="matrix__addon_8c_source.html#l00357">Matrix_subMatrix()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="matrix_8c_source.html#l00435">right_hermite()</a>, <a class="el" href="matrix__addon_8h_source.html#l00032">show_matrix</a>, and <a class="el" href="vector_8c_source.html#l00747">Vector_IsZero()</a>.</p>

</div>
</div>
<a class="anchor" id="a091ae8062b33511134d13b0035a56777"></a><!-- doxytag: member="compress_parms.c::int_mod_basis" ref="a091ae8062b33511134d13b0035a56777" args="(Matrix *B, Matrix *C, Matrix *d)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structmatrix.html">Matrix</a>* int_mod_basis </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>B</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>C</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>d</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>kept here for backwards compatiblity. </p>
<p>Wrapper to <a class="el" href="compress__parms_8c.html#a12b7b863af43c3d85682b9df2385938c" title="Given an integer matrix B with m rows and integer m-vectors C and d, computes the...">Equalities_intModBasis()</a> </p>

<p>Definition at line <a class="el" href="compress__parms_8c_source.html#l00614">614</a> of file <a class="el" href="compress__parms_8c_source.html">compress_parms.c</a>.</p>

<p>References <a class="el" href="compress__parms_8c_source.html#l00592">Equalities_intModBasis()</a>.</p>

</div>
</div>
<a class="anchor" id="a9a39676ea22cef575c08911c95badba2"></a><!-- doxytag: member="compress_parms.c::Lattice_extractSubLattice" ref="a9a39676ea22cef575c08911c95badba2" args="(Matrix *lat, unsigned int k, Matrix **subLat)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Lattice_extractSubLattice </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>lat</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&nbsp;</td>
          <td class="paramname"> <em>k</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>subLat</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Given a <a class="el" href="structmatrix.html">matrix</a> that defines a full-dimensional affine lattice, returns the affine sub-lattice spanned in the k first dimensions. </p>
<p>Useful for instance when you only look for the parameters' validity lattice. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>lat</em>&nbsp;</td><td>the original full-dimensional lattice </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>subLat</em>&nbsp;</td><td>the sublattice </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="compress__parms_8c_source.html#l00499">499</a> of file <a class="el" href="compress__parms_8c_source.html">compress_parms.c</a>.</p>

<p>References <a class="el" href="assert_8h_source.html#l00026">assert</a>, <a class="el" href="compress__parms_8c_source.html#l00039">dbgCompParmMore</a>, <a class="el" href="compress__parms_8c_source.html#l00045">dbgEnd</a>, <a class="el" href="compress__parms_8c_source.html#l00041">dbgStart</a>, <a class="el" href="compress__parms_8c_source.html#l00499">Lattice_extractSubLattice()</a>, <a class="el" href="matrix_8c_source.html#l00505">left_hermite()</a>, <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="Matop_8c_source.html#l00118">Matrix_Copy()</a>, <a class="el" href="matrix__addon_8c_source.html#l00394">Matrix_copySubMatrix()</a>, <a class="el" href="matrix_8c_source.html#l00092">Matrix_Free()</a>, <a class="el" href="matrix__addon_8c_source.html#l00357">Matrix_subMatrix()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="matrix__addon_8h_source.html#l00032">show_matrix</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00460">value_set_si</a>.</p>

<p>Referenced by <a class="el" href="compress__parms_8c_source.html#l00499">Lattice_extractSubLattice()</a>, and <a class="el" href="testCompressParms_8c_source.html#l00273">test_Constraints_fullDimensionize()</a>.</p>

</div>
</div>
<a class="anchor" id="a8b044a0b5721eb247eb671644b80df9d"></a><!-- doxytag: member="compress_parms.c::linearInter" ref="a8b044a0b5721eb247eb671644b80df9d" args="(Matrix *A, Matrix *B, Matrix **I, Matrix **Lb)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void linearInter </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>A</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>B</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>I</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>Lb</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Computes the intersection of two linear lattices, whose base vectors are respectively represented in A and B. </p>
<p>If I and/or Lb is set to NULL, then the <a class="el" href="structmatrix.html">matrix</a> is allocated. Else, the <a class="el" href="structmatrix.html">matrix</a> is assumed to be allocated already. I and Lb are rk x rk, where rk is the rank of A (or B). </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>A</em>&nbsp;</td><td>the full-row rank <a class="el" href="structmatrix.html">matrix</a> whose column-vectors are the basis for the first linear lattice. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>B</em>&nbsp;</td><td>the <a class="el" href="structmatrix.html">matrix</a> whose column-vectors are the basis for the second linear lattice. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>Lb</em>&nbsp;</td><td>the <a class="el" href="structmatrix.html">matrix</a> such that B.Lb = I, where I is the intersection. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>their intersection. </dd></dl>

<p>Definition at line <a class="el" href="compress__parms_8c_source.html#l00119">119</a> of file <a class="el" href="compress__parms_8c_source.html">compress_parms.c</a>.</p>

<p>References <a class="el" href="assert_8h_source.html#l00026">assert</a>, <a class="el" href="compress__parms_8c_source.html#l00038">dbgCompParm</a>, <a class="el" href="matrix_8c_source.html#l00505">left_hermite()</a>, <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="matrix__addon_8c_source.html#l00394">Matrix_copySubMatrix()</a>, <a class="el" href="matrix_8c_source.html#l00092">Matrix_Free()</a>, <a class="el" href="matrix__addon_8c_source.html#l00357">Matrix_subMatrix()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="matrix__addon_8h_source.html#l00032">show_matrix</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00460">value_set_si</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00553">value_zero_p</a>.</p>

<p>Referenced by <a class="el" href="compress__parms_8c_source.html#l00271">Equalities_validityLattice()</a>.</p>

</div>
</div>
<a class="anchor" id="a86df15994f14c73d49980bbf61f6f7e5"></a><!-- doxytag: member="compress_parms.c::Polyhedron_Remove_parm_eqs" ref="a86df15994f14c73d49980bbf61f6f7e5" args="(Polyhedron **P, Polyhedron **C, int renderSpace, unsigned int **elimParms, int maxRays)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structpolyhedron.html">Polyhedron</a>* Polyhedron_Remove_parm_eqs </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpolyhedron.html">Polyhedron</a> **&nbsp;</td>
          <td class="paramname"> <em>P</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structpolyhedron.html">Polyhedron</a> **&nbsp;</td>
          <td class="paramname"> <em>C</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>renderSpace</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int **&nbsp;</td>
          <td class="paramname"> <em>elimParms</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>maxRays</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Removes equalities involving only parameters, but starting from a Polyhedron and its context. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>P</em>&nbsp;</td><td>the <a class="el" href="structpolyhedron.html">polyhedron</a> </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>C</em>&nbsp;</td><td>P's context </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>renderSpace,:</em>&nbsp;</td><td>0 for the parameter space, =1 for the combined space.  Polylib's usual <em>workspace</em>. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="compress__parms_8c_source.html#l00856">856</a> of file <a class="el" href="compress__parms_8c_source.html">compress_parms.c</a>.</p>

<p>References <a class="el" href="polyhedron_8c_source.html#l01906">Constraints2Polyhedron()</a>, <a class="el" href="compress__parms_8c_source.html#l00649">Constraints_Remove_parm_eqs()</a>, <a class="el" href="types_8h_source.html#l00107">F_ISSET</a>, <a class="el" href="types_8h_source.html#l00099">FL_INIT</a>, <a class="el" href="matrix_8c_source.html#l00092">Matrix_Free()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00116">POL_INEQUALITIES</a>, <a class="el" href="types_8h_source.html#l00082">POL_NO_DUAL</a>, <a class="el" href="types_8h_source.html#l00123">POL_VALID</a>, <a class="el" href="polyhedron_8c_source.html#l02056">Polyhedron2Constraints()</a>, and <a class="el" href="polyhedron_8c_source.html#l01603">Polyhedron_Free()</a>.</p>

<p>Referenced by <a class="el" href="testCompressParms_8c_source.html#l00139">test_Polyhedron_Remove_parm_eqs()</a>.</p>

</div>
</div>
</div>
<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Nov 25 17:45:26 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
